MODULE pac_refresh;

{ Copyright (C) 1985, IMAGEN Corporation                                    }
{ This software may be duplicated in part of in whole so long as [1] this   }
{ notice is preserved in the copy, and [2] no financial gain is derived     }
{ from the copy.  Copies of this software other than as restricted above    }
{ may be made only with the consent of the author.                          }

%include '/sys/ins/base.ins.pas';
%include '/sys/ins/error.ins.pas';
%include '/sys/ins/kbd.ins.pas';
%include '/sys/ins/gpr.ins.pas';
%include '/sys/ins/pgm.ins.pas';
%include '/sys/ins/pad.ins.pas';
%include '/sys/ins/time.ins.pas';
%include '/sys/ins/tone.ins.pas';

%include 'fig.ins.pas';   {mobile_figure module}
%include 'board.ins.pas'; {pacman_board module}


VAR
    last_tick: extern time_$clock_t;
    pac: extern fig_$t;
    nasties: extern array[1..15] of fig_$t;
    num_nasties: extern integer;

PROCEDURE pacm_$noop;
BEGIN
    { do nothing }
END;

PROCEDURE pacm_$refresh_all;
VAR
    i: integer;
BEGIN
    board_$draw_board;
    fig_$refresh(pac);
    for i := 1 to num_nasties do
        fig_$refresh(nasties[i]);
    time_$clock(last_tick)
END;

PROCEDURE pacm_$refresh_part(IN unobscured, pos_change: boolean);
BEGIN
    if unobscured or pos_change then
        pacm_$refresh_all;
END;

